Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limthd_zdf_2.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 1854)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 1855)
@@ -73,328 +72,322 @@
       !!
       INTEGER ::   ji       ! dummy loop indices
-      REAL(wp), DIMENSION(jpij,2) ::   zqcmlt        ! energy due to surface( /1 ) and bottom melting( /2 )
-      REAL(wp), DIMENSION(jpij) ::  &
-         ztsmlt      &    ! snow/ice surface melting temperature
-         ,ztbif      &    ! int. temp. at the mid-point of the 1st layer of the snow/ice sys. 
-         ,zksn       &    ! effective conductivity of snow
-         ,zkic       &    ! effective conductivity of ice
-         ,zksndh     &    ! thermal cond. at the mid-point of the 1st layer of the snow/ice sys. 
-         , zfcsu     &    ! conductive heat flux at the surface of the snow/ice system 
-         , zfcsudt   &    ! = zfcsu * dt
-         , zi0       &    ! frac. of the net SW rad. which is not absorbed at the surface
-         , z1mi0     &    ! fraction of the net SW radiation absorbed at the surface
-         , zqmax     &    ! maximum energy stored in brine pockets
-         , zrcpdt    &    ! h_su*rho_su*cp_su/dt(h_su being the thick. of surf. layer)
-         , zts_old   &    ! previous surface temperature
-         , zidsn , z1midsn , zidsnic ! tempory variables
-      REAL(wp), DIMENSION(jpij) ::   &
-          zfnet       &  ! net heat flux at the top surface( incl. conductive heat flux)
-          , zsprecip  &    ! snow accumulation
-          , zhsnw_old &    ! previous snow thickness
-          , zdhictop  &    ! change in ice thickness due to top surf ablation/accretion
-          , zdhicbot  &    ! change in ice thickness due to bottom surf abl/acc
-          , zqsup     &    ! energy transmitted to ocean (coming from top surf abl/acc)
-          , zqocea    &    ! energy transmitted to ocean (coming from bottom sur abl/acc)
-          , zfrl_old  &    ! previous sea/ice fraction
-          , zfrld_1d    &    ! new sea/ice fraction
-          , zep            ! internal temperature of the 2nd layer of the snow/ice system
-       REAL(wp), DIMENSION(3) :: & 
-          zplediag  &    ! principle diagonal, subdiag. and supdiag. of the 
-          , zsubdiag  &    ! tri-diagonal matrix coming from the computation
-          , zsupdiag  &    ! of the temperatures inside the snow-ice system
-          , zsmbr          ! second member
-       REAL(wp) :: & 
-          zhsu     &     ! thickness of surface layer
-          , zhe      &     ! effective thickness for compu. of equ. thermal conductivity
-          , zheshth  &     ! = zhe / thth
-          , zghe     &     ! correction factor of the thermal conductivity
-          , zumsb    &     ! parameter for numerical method to solve heat-diffusion eq.
-          , zkhsn    &     ! conductivity at the snow layer
-          , zkhic    &     ! conductivity at the ice layers
-          , zkint    &     ! equivalent conductivity at the snow-ice interface
-          , zkhsnint &     ! = zkint*dt / (hsn*rhosn*cpsn)  
-          , zkhicint &     ! = 2*zkint*dt / (hic*rhoic*cpic)
-          , zpiv1 , zpiv2  &       ! tempory scalars used to solve the tri-diagonal system
-          , zb2 , zd2 , zb3 , zd3 &
-          , ztint          ! equivalent temperature at the snow-ice interface
-       REAL(wp) :: & 
-          zexp      &     ! exponential function of the ice thickness
-          , zfsab     &     ! part of solar radiation stored in brine pockets
-          , zfts      &     ! value of energy balance function when the temp. equal surf. temp.
-          , zdfts     &     ! value of derivative of ztfs when the temp. equal surf. temp.
-          , zdts      &     ! surface temperature increment
-          , zqsnw_mlt &     ! energy needed to melt snow
-          , zdhsmlt   &     ! change in snow thickness due to melt
-          , zhsn      &     ! snow thickness (previous+accumulation-melt)
-          , zqsn_mlt_rem &  ! remaining heat coming from snow melting
-          , zqice_top_mlt & ! energy used to melt ice at top surface
-          , zdhssub      &  ! change in snow thick. due to sublimation or evaporation
-          , zdhisub      &  ! change in ice thick. due to sublimation or evaporation    
-          , zdhsn        &  ! snow ice thickness increment
-          , zdtsn        &  ! snow internal temp. increment
-          , zdtic        &  ! ice internal temp. increment
-          , zqnes          ! conductive energy due to ice melting in the first ice layer
-       REAL(wp) :: & 
-          ztbot     &      ! temperature at the bottom surface
-          , zfcbot    &      ! conductive heat flux at bottom surface
-          , zqice_bot &      ! energy used for bottom melting/growing
-          , zqice_bot_mlt &  ! energy used for bottom melting
-          , zqstbif_bot  &  ! part of energy stored in brine pockets used for bottom melting
-          , zqstbif_old  &  ! tempory var. for zqstbif_bot
-          , zdhicmlt      &  ! change in ice thickness due to bottom melting
-          , zdhicm        &  ! change in ice thickness var. 
-          , zdhsnm        &  ! change in snow thickness var. 
-          , zhsnfi        &  ! snow thickness var. 
-          , zc1, zpc1, zc2, zpc2, zp1, zp2 & ! tempory variables
-          , ztb2, ztb3
-       REAL(wp) :: & 
-          zdrmh         &   ! change in snow/ice thick. after snow-ice formation
-          , zhicnew       &   ! new ice thickness
-          , zhsnnew       &   ! new snow thickness
-          , zquot , ztneq &   ! tempory temp. variables
-          , zqice, zqicetot & ! total heat inside the snow/ice system
-          , zdfrl         &   ! change in ice concentration
-          , zdvsnvol      &   ! change in snow volume
-          , zdrfrl1, zdrfrl2 &  ! tempory scalars
-          , zihsn, zidhb, zihic, zihe, zihq, ziexp, ziqf, zihnf, zibmlt, ziqr, zihgnew, zind
-       !!----------------------------------------------------------------------
-
-       !-----------------------------------------------------------------------
-       !  1. Boundaries conditions for snow/ice system internal temperature
-       !       - If tbif_1d(ji,1) > rt0_snow, tbif_1d(ji,1) = rt0_snow 
-       !       - If tbif_1d(ji,2/3) > rt0_ice, tbif_1d(ji,2/3) = rt0_ice 
-       !     Computation of energies due to surface and bottom melting 
-       !-----------------------------------------------------------------------
-       
-       DO ji = kideb , kiut
-          zihsn = MAX( zzero , SIGN( zone , hsndif - h_snow_1d(ji) ) )
-          zihic = MAX( zzero , SIGN( zone , hicdif - h_ice_1d(ji) ) )
-          !--computation of energy due to surface melting
-          zqcmlt(ji,1) = ( MAX ( zzero ,  &
-             &                   rcpsn * h_snow_1d(ji) * ( tbif_1d(ji,1) - rt0_snow ) ) ) * ( 1.0 - zihsn )
-          !--computation of energy due to bottom melting
-          zqcmlt(ji,2) = ( MAX( zzero , &
-             &                  rcpic * ( tbif_1d(ji,2) - rt0_ice ) * ( h_ice_1d(ji) / 2. ) ) &
-             &           + MAX( zzero , &
-             &                  rcpic * ( tbif_1d(ji,3) - rt0_ice ) * ( h_ice_1d(ji) / 2. ) ) &
-             &           ) * ( 1.0 - zihic  )
-          !--limitation of  snow/ice system internal temperature
-          tbif_1d(ji,1)   = MIN( rt0_snow, tbif_1d(ji,1) )
-          tbif_1d(ji,2)   = MIN( rt0_ice , tbif_1d(ji,2) )
-          tbif_1d(ji,3)   = MIN( rt0_ice , tbif_1d(ji,3) )
-       END DO
-
-       !-------------------------------------------
-       !  2. Calculate some intermediate variables.  
-       !-------------------------------------------
-       
-       ! initialisation of the thickness of surface layer
-       zhsu = hnzst  
-
-       DO ji = kideb , kiut
-          zind   = MAX( zzero , SIGN( zone , zhsu - h_snow_1d(ji) ) )
-          zihsn  = MAX( zzero , SIGN( zone , hsndif - h_snow_1d(ji) ) )
-          zihsn  = MAX( zihsn , zind )
-          zihic  = MAX( zzero , sign( zone , hicdif - h_ice_1d(ji) ) )
-          !     2.1. Computation of surface melting temperature
-          !----------------------------------------------------
-          zind  = MAX( zzero , SIGN( zone , -h_snow_1d(ji) ) )
-          ztsmlt(ji) = ( 1.0 - zind ) * rt0_snow + zind * rt0_ice
-          !
-          !     2.2. Effective conductivity of snow and ice
-          !-----------------------------------------------
-
-          !---computation of the correction factor on the thermal conductivity
-          !-- (Morales Maqueda, 1995 ; Fichefet and Morales Maqueda, 1997)
-          zhe      =  ( rcdsn / ( rcdsn + rcdic ) ) * h_ice_1d(ji)   &
-             &     + ( rcdic / ( rcdsn + rcdic ) ) * h_snow_1d(ji) 
-          zihe     = MAX( zzero , SIGN( zone , 2.0 * zhe - thth ) )
-          zheshth  = zhe / thth
-          zghe     = ( 1.0 - zihe ) * zheshth * ( 2.0 - zheshth )   &
-             &     +         zihe   * 0.5 * ( 1.5 + LOG( 2.0 * zheshth ) )
-
-          !---effective conductivities 
-          zksn(ji)  = zghe * rcdsn  
-          zkic(ji)  = zghe * rcdic
-
-          !
-          !     2.3. Computation of the conductive heat flux from the snow/ice 
-          !          system interior toward the top surface
-          !------------------------------------------------------------------
-
-          !---Thermal conductivity at the mid-point of the first snow/ice system layer
-          zksndh(ji) =   ( ( 1.0 - zihsn ) * 2.0 * zksn(ji) + zihsn * 4.0 * zkic(ji) )   &
-             &         / ( ( 1.0 - zihsn ) *  h_snow_1d(ji)                              &
-             &           +        zihsn   *  ( ( 1.0 + 3.0 * zihic ) * h_ice_1d(ji)      &
-             &           + 4.0 * zkic(ji)/zksn(ji) * h_snow_1d(ji) ) )
-
-          !---internal temperature at the mid-point of the first snow/ice system layer
-          ztbif(ji)  = ( 1.0 - zihsn ) * tbif_1d(ji,1)                       &
-             &       +         zihsn   * ( ( 1.0 - zihic ) * tbif_1d(ji,2)   &
-             &       +         zihic   * tfu_1d(ji)   )
-          !---conductive heat flux 
-          zfcsu(ji) = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
-
-       END DO
-
-       !--------------------------------------------------------------------
-       !  3. Calculate : 
-       !     - fstbif_1d, part of solar radiation absorbing inside the ice
-       !       assuming an exponential absorption (Grenfell and Maykut, 1977)
-       !     - zqmax,  maximum energy stored in brine pockets
-       !     - qstbif_1d, total energy stored in brine pockets (updating)
-       !-------------------------------------------------------------------
-
-       DO ji = kideb , kiut
-          zihsn  = MAX( zzero , SIGN (zone , -h_snow_1d(ji) ) )
-          zihic  = MAX( zzero , 1.0 - ( h_ice_1d(ji) / zhsu ) )     
-          zind   = MAX( zzero , SIGN (zone , hicdif - h_ice_1d(ji) ) )
-          !--Computation of the fraction of the net shortwave radiation which
-          !--penetrates inside the ice cover ( See Forcat)
-          zi0(ji)  = zihsn * ( fr1_i0_1d(ji) + zihic * fr2_i0_1d(ji) )
-          zexp     = MIN( zone , EXP( -1.5 * ( h_ice_1d(ji) - zhsu ) ) )
-          fstbif_1d(ji) = zi0(ji) * qsr_ice_1d(ji) * zexp
-          !--Computation of maximum energy stored in brine pockets zqmax and update
-          !--the total energy stored in brine pockets, if less than zqmax
-          zqmax(ji) = MAX( zzero , 0.5 * xlic * ( h_ice_1d(ji) - hicmin ) )
-          zfsab   = zi0(ji) * qsr_ice_1d(ji) * ( 1.0 - zexp )
-          zihq    = ( 1.0 - zind ) * MAX(zzero, SIGN( zone , qstbif_1d(ji) - zqmax(ji) ) ) &
-             &    +         zind   * zone
-          qstbif_1d(ji) = ( qstbif_1d(ji) + ( 1.0 - zihq ) * zfsab * rdt_ice ) * swiqst
-          !--fraction of shortwave radiation absorbed at surface
-          ziexp = zihq * zexp + ( 1.0 - zihq ) * ( swiqst + ( 1.0 - swiqst ) * zexp )
-          z1mi0(ji) = 1.0 - zi0(ji) * ziexp
-       END DO
-
-       !--------------------------------------------------------------------------------
-       !  4. Computation of the surface temperature : determined by considering the 
-       !     budget of a thin layer of thick. zhsu at the top surface (H. Grenier, 1995) 
-       !     and based on a surface energy balance : 
-       !     hsu * rcp * dT/dt = Fsr + Fnsr(T) + Fcs(T),
-       !     where - Fsr is the net absorbed solar radiation, 
-       !           - Fnsr is the total non solar radiation (incoming and outgoing long-wave,
-       !             sensible and latent heat fluxes)
-       !           - Fcs the conductive heat flux at the top of surface
-       !------------------------------------------------------------------------------
-
-       !     4.1. Computation of intermediate values
-       !---------------------------------------------
-       DO ji = kideb, kiut
-          zrcpdt(ji) = ( rcpsn * MIN( h_snow_1d(ji) , zhsu )    &
-             &       + rcpic * MAX( zhsu - h_snow_1d(ji) , zzero ) ) / rdt_ice
-          zts_old(ji) =  sist_1d(ji)
-       END DO
-
-       !     4.2. Computation of surface temperature by expanding the eq. of energy balance
-       !          with Ts = Tp + DT. One obtain , F(Tp) + DT * DF(Tp) = 0
-       !          where  - F(Tp) = Fsr + Fnsr(Tp) + Fcs(Tp) 
-       !                 - DF(Tp)= (dFnsr(Tp)/dT) + (dFcs(Tp)/dT) - hsu*rcp/dt
-       !---------------------------------------------------------------------------------
-
-       DO ji = kideb, kiut
-          !---computation of the derivative of energy balance function 
-          zdfts    =  zksndh(ji)   & ! contribution of the conductive heat flux
-             &      + zrcpdt(ji)   & ! contribution of hsu * rcp / dt
-             &      - dqns_ice_1d (ji)     ! contribution of the total non solar radiation 
-          !---computation of the energy balance function 
-          zfts    = - z1mi0 (ji) * qsr_ice_1d(ji)   & ! net absorbed solar radiation
-             &      - qns_ice_1d(ji)                & ! total non solar radiation
-             &      - zfcsu (ji)                      ! conductive heat flux from the surface
-          !---computation of surface temperature increment  
-          zdts    = -zfts / zdfts
-          !---computation of the new surface temperature 
-          sist_1d(ji) = sist_1d(ji) + zdts
-       END DO
-
-       !----------------------------------------------------------------------------
-       !  5. Boundary condition at the top surface
-       !--    IF Tsb < Tmelt, Fnet = Fcs (the net heat flux equal the conductive heat flux)
-       !      Otherwise Tsb = Tmelt and Qnet(Tmelt) > 0 
-       !      Fnet(Tmelt) is therefore the net surface flux needed for melting
-       !----------------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpij,2) ::   zqcmlt   ! energy due to surface( /1 ) and bottom melting( /2 )
+      REAL(wp), DIMENSION(jpij) ::   ztsmlt     ! snow/ice surface melting temperature
+      REAL(wp), DIMENSION(jpij) ::   ztbif      ! int. temp. at the mid-point of the 1st layer of the snow/ice sys. 
+      REAL(wp), DIMENSION(jpij) ::   zksn       ! effective conductivity of snow
+      REAL(wp), DIMENSION(jpij) ::   zkic       ! effective conductivity of ice
+      REAL(wp), DIMENSION(jpij) ::   zksndh     ! thermal cond. at the mid-point of the 1st layer of the snow/ice sys. 
+      REAL(wp), DIMENSION(jpij) ::   zfcsu      ! conductive heat flux at the surface of the snow/ice system 
+      REAL(wp), DIMENSION(jpij) ::   zfcsudt    ! = zfcsu * dt
+      REAL(wp), DIMENSION(jpij) ::   zi0        ! frac. of the net SW rad. which is not absorbed at the surface
+      REAL(wp), DIMENSION(jpij) ::   z1mi0      ! fraction of the net SW radiation absorbed at the surface
+      REAL(wp), DIMENSION(jpij) ::   zqmax      ! maximum energy stored in brine pockets
+      REAL(wp), DIMENSION(jpij) ::   zrcpdt     ! h_su*rho_su*cp_su/dt(h_su being the thick. of surf. layer)
+      REAL(wp), DIMENSION(jpij) ::   zts_old    ! previous surface temperature
+      REAL(wp), DIMENSION(jpij) ::   zidsn , z1midsn , zidsnic ! tempory variables
+      !!
+      REAL(wp), DIMENSION(jpij) ::   zfnet       ! net heat flux at the top surface( incl. conductive heat flux)
+      REAL(wp), DIMENSION(jpij) ::   zsprecip    ! snow accumulation
+      REAL(wp), DIMENSION(jpij) ::   zhsnw_old   ! previous snow thickness
+      REAL(wp), DIMENSION(jpij) ::   zdhictop    ! change in ice thickness due to top surf ablation/accretion
+      REAL(wp), DIMENSION(jpij) ::   zdhicbot    ! change in ice thickness due to bottom surf abl/acc
+      REAL(wp), DIMENSION(jpij) ::   zqsup       ! energy transmitted to ocean (coming from top surf abl/acc)
+      REAL(wp), DIMENSION(jpij) ::   zqocea      ! energy transmitted to ocean (coming from bottom sur abl/acc)
+      REAL(wp), DIMENSION(jpij) ::   zfrl_old    ! previous sea/ice fraction
+      REAL(wp), DIMENSION(jpij) ::   zfrld_1d    ! new sea/ice fraction
+      REAL(wp), DIMENSION(jpij) ::   zep         ! internal temperature of the 2nd layer of the snow/ice system
+      !!
+      REAL(wp), DIMENSION(3) ::   zplediag       ! principle diagonal, subdiag. and supdiag. of the 
+      REAL(wp), DIMENSION(3) ::   zsubdiag       ! tri-diagonal matrix coming from the computation
+      REAL(wp), DIMENSION(3) ::   zsupdiag       ! of the temperatures inside the snow-ice system
+      REAL(wp), DIMENSION(3) ::   zsmbr          ! second member
+      REAL(wp) ::   zhsu        ! thickness of surface layer
+      REAL(wp) ::   zhe         ! effective thickness for compu. of equ. thermal conductivity
+      REAL(wp) ::   zheshth     ! = zhe / thth
+      REAL(wp) ::   zghe        ! correction factor of the thermal conductivity
+      REAL(wp) ::   zumsb       ! parameter for numerical method to solve heat-diffusion eq.
+      REAL(wp) ::   zkhsn       ! conductivity at the snow layer
+      REAL(wp) ::   zkhic       ! conductivity at the ice layers
+      REAL(wp) ::   zkint       ! equivalent conductivity at the snow-ice interface
+      REAL(wp) ::   zkhsnint    ! = zkint*dt / (hsn*rhosn*cpsn)  
+      REAL(wp) ::   zkhicint    ! = 2*zkint*dt / (hic*rhoic*cpic)
+      REAL(wp) ::   zpiv1 , zpiv2        ! tempory scalars used to solve the tri-diagonal system
+      REAL(wp) ::   zb2, zd2, zb3, zd3
+      REAL(wp) ::   ztint          ! equivalent temperature at the snow-ice interface
+      REAL(wp) ::   zexp         ! exponential function of the ice thickness
+      REAL(wp) ::   zfsab        ! part of solar radiation stored in brine pockets
+      REAL(wp) ::   zfts         ! value of energy balance function when the temp. equal surf. temp.
+      REAL(wp) ::   zdfts        ! value of derivative of ztfs when the temp. equal surf. temp.
+      REAL(wp) ::   zdts         ! surface temperature increment
+      REAL(wp) ::   zqsnw_mlt    ! energy needed to melt snow
+      REAL(wp) ::   zdhsmlt      ! change in snow thickness due to melt
+      REAL(wp) ::   zhsn         ! snow thickness (previous+accumulation-melt)
+      REAL(wp) ::   zqsn_mlt_rem   ! remaining heat coming from snow melting
+      REAL(wp) ::   zqice_top_mlt   ! energy used to melt ice at top surface
+      REAL(wp) ::   zdhssub        ! change in snow thick. due to sublimation or evaporation
+      REAL(wp) ::   zdhisub        ! change in ice thick. due to sublimation or evaporation    
+      REAL(wp) ::   zdhsn          ! snow ice thickness increment
+      REAL(wp) ::   zdtsn          ! snow internal temp. increment
+      REAL(wp) ::   zdtic          ! ice internal temp. increment
+      REAL(wp) ::   zqnes          ! conductive energy due to ice melting in the first ice layer
+      !!
+      REAL(wp) ::   ztbot           ! temperature at the bottom surface
+      REAL(wp) ::   zfcbot          ! conductive heat flux at bottom surface
+      REAL(wp) ::   zqice_bot       ! energy used for bottom melting/growing
+      REAL(wp) ::   zqice_bot_mlt   ! energy used for bottom melting
+      REAL(wp) ::   zqstbif_bot    ! part of energy stored in brine pockets used for bottom melting
+      REAL(wp) ::   zqstbif_old    ! tempory var. for zqstbif_bot
+      REAL(wp) ::   zdhicmlt        ! change in ice thickness due to bottom melting
+      REAL(wp) ::   zdhicm          ! change in ice thickness var. 
+      REAL(wp) ::   zdhsnm          ! change in snow thickness var. 
+      REAL(wp) ::   zhsnfi          ! snow thickness var. 
+      REAL(wp) ::   zc1, zpc1, zc2, zpc2, zp1, zp2   ! temporary scalars
+      REAL(wp) ::   ztb2, ztb3
+      !!
+      REAL(wp) ::   zdrmh           ! change in snow/ice thick. after snow-ice formation
+      REAL(wp) ::   zhicnew         ! new ice thickness
+      REAL(wp) ::   zhsnnew         ! new snow thickness
+      REAL(wp) ::   zquot , ztneq   ! tempory temp. variables
+      REAL(wp) ::   zqice, zqicetot & ! total heat inside the snow/ice system
+      REAL(wp) ::   zdfrl           ! change in ice concentration
+      REAL(wp) ::   zdvsnvol        ! change in snow volume
+      REAL(wp) ::   zdrfrl1, zdrfrl2   ! tempory scalars
+      REAL(wp) ::   zihsn, zidhb, zihic, zihe, zihq, ziexp, ziqf, zihnf, zibmlt, ziqr, zihgnew, zind
+      !!----------------------------------------------------------------------
+
+      !-----------------------------------------------------------------------
+      !  1. Boundaries conditions for snow/ice system internal temperature
+      !       - If tbif_1d(ji,1) > rt0_snow, tbif_1d(ji,1) = rt0_snow 
+      !       - If tbif_1d(ji,2/3) > rt0_ice, tbif_1d(ji,2/3) = rt0_ice 
+      !     Computation of energies due to surface and bottom melting 
+      !-----------------------------------------------------------------------
+      DO ji = kideb , kiut
+         zihsn = MAX( zzero , SIGN( zone , hsndif - h_snow_1d(ji) ) )
+         zihic = MAX( zzero , SIGN( zone , hicdif - h_ice_1d(ji) ) )
+         !--computation of energy due to surface melting
+         zqcmlt(ji,1) = ( MAX ( zzero ,  &
+            &                   rcpsn * h_snow_1d(ji) * ( tbif_1d(ji,1) - rt0_snow ) ) ) * ( 1.0 - zihsn )
+         !--computation of energy due to bottom melting
+         zqcmlt(ji,2) = ( MAX( zzero , &
+            &                  rcpic * ( tbif_1d(ji,2) - rt0_ice ) * ( h_ice_1d(ji) / 2. ) ) &
+            &           + MAX( zzero , &
+            &                  rcpic * ( tbif_1d(ji,3) - rt0_ice ) * ( h_ice_1d(ji) / 2. ) ) &
+            &           ) * ( 1.0 - zihic  )
+         !--limitation of  snow/ice system internal temperature
+         tbif_1d(ji,1)   = MIN( rt0_snow, tbif_1d(ji,1) )
+         tbif_1d(ji,2)   = MIN( rt0_ice , tbif_1d(ji,2) )
+         tbif_1d(ji,3)   = MIN( rt0_ice , tbif_1d(ji,3) )
+      END DO
+
+      !-------------------------------------------
+      !  2. Calculate some intermediate variables.  
+      !-------------------------------------------
+      zhsu = hnzst         ! initialisation of the thickness of surface layer
+      !
+      DO ji = kideb , kiut
+         zind   = MAX(  zzero , SIGN( zone , zhsu   - h_snow_1d(ji) )  )
+         zihsn  = MAX(  zzero , SIGN( zone , hsndif - h_snow_1d(ji) )  )
+         zihsn  = MAX(  zihsn , zind                                   )
+         zihic  = MAX(  zzero , sign( zone , hicdif - h_ice_1d (ji) )  )
+         !
+         !     2.1. Computation of surface melting temperature
+         !----------------------------------------------------
+         zind  = MAX( zzero , SIGN( zone , -h_snow_1d(ji) ) )
+         ztsmlt(ji) = ( 1.0 - zind ) * rt0_snow + zind * rt0_ice
+         !
+         !     2.2. Effective conductivity of snow and ice
+         !-----------------------------------------------
+
+         !---computation of the correction factor on the thermal conductivity
+         !-- (Morales Maqueda, 1995 ; Fichefet and Morales Maqueda, 1997)
+         zhe      =  ( rcdsn / ( rcdsn + rcdic ) ) * h_ice_1d(ji)   &
+            &     + ( rcdic / ( rcdsn + rcdic ) ) * h_snow_1d(ji) 
+         zihe     = MAX( zzero , SIGN( zone , 2.0 * zhe - thth ) )
+         zheshth  = zhe / thth
+         zghe     = ( 1.0 - zihe ) * zheshth * ( 2.0 - zheshth )   &
+            &     +         zihe   * 0.5 * ( 1.5 + LOG( 2.0 * zheshth ) )
+
+         !---effective conductivities 
+         zksn(ji)  = zghe * rcdsn  
+         zkic(ji)  = zghe * rcdic
+         !
+         !     2.3. Computation of the conductive heat flux from the snow/ice 
+         !          system interior toward the top surface
+         !------------------------------------------------------------------
+
+         !---Thermal conductivity at the mid-point of the first snow/ice system layer
+         zksndh(ji) =   ( ( 1.0 - zihsn ) * 2.0 * zksn(ji) + zihsn * 4.0 * zkic(ji) )   &
+            &         / ( ( 1.0 - zihsn ) *  h_snow_1d(ji)                              &
+            &           +        zihsn   *  ( ( 1.0 + 3.0 * zihic ) * h_ice_1d(ji)      &
+            &           + 4.0 * zkic(ji)/zksn(ji) * h_snow_1d(ji) ) )
+
+         !---internal temperature at the mid-point of the first snow/ice system layer
+         ztbif(ji)  = ( 1.0 - zihsn ) * tbif_1d(ji,1)                       &
+            &       +         zihsn   * ( ( 1.0 - zihic ) * tbif_1d(ji,2)   &
+            &       +         zihic   * tfu_1d(ji)   )
+         !---conductive heat flux 
+         zfcsu(ji) = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
+
+      END DO
+
+      !--------------------------------------------------------------------
+      !  3. Calculate : 
+      !     - fstbif_1d, part of solar radiation absorbing inside the ice
+      !       assuming an exponential absorption (Grenfell and Maykut, 1977)
+      !     - zqmax,  maximum energy stored in brine pockets
+      !     - qstbif_1d, total energy stored in brine pockets (updating)
+      !-------------------------------------------------------------------
+
+      DO ji = kideb , kiut
+         zihsn  = MAX( zzero , SIGN (zone , -h_snow_1d(ji) ) )
+         zihic  = MAX( zzero , 1.0 - ( h_ice_1d(ji) / zhsu ) )     
+         zind   = MAX( zzero , SIGN (zone , hicdif - h_ice_1d(ji) ) )
+         !--Computation of the fraction of the net shortwave radiation which
+         !--penetrates inside the ice cover ( See Forcat)
+         zi0(ji)  = zihsn * ( fr1_i0_1d(ji) + zihic * fr2_i0_1d(ji) )
+         zexp     = MIN( zone , EXP( -1.5 * ( h_ice_1d(ji) - zhsu ) ) )
+         fstbif_1d(ji) = zi0(ji) * qsr_ice_1d(ji) * zexp
+         !--Computation of maximum energy stored in brine pockets zqmax and update
+         !--the total energy stored in brine pockets, if less than zqmax
+         zqmax(ji) = MAX( zzero , 0.5 * xlic * ( h_ice_1d(ji) - hicmin ) )
+         zfsab   = zi0(ji) * qsr_ice_1d(ji) * ( 1.0 - zexp )
+         zihq    = ( 1.0 - zind ) * MAX(zzero, SIGN( zone , qstbif_1d(ji) - zqmax(ji) ) ) &
+            &    +         zind   * zone
+         qstbif_1d(ji) = ( qstbif_1d(ji) + ( 1.0 - zihq ) * zfsab * rdt_ice ) * swiqst
+         !--fraction of shortwave radiation absorbed at surface
+         ziexp = zihq * zexp + ( 1.0 - zihq ) * ( swiqst + ( 1.0 - swiqst ) * zexp )
+         z1mi0(ji) = 1.0 - zi0(ji) * ziexp
+      END DO
+
+      !--------------------------------------------------------------------------------
+      !  4. Computation of the surface temperature : determined by considering the 
+      !     budget of a thin layer of thick. zhsu at the top surface (H. Grenier, 1995) 
+      !     and based on a surface energy balance : 
+      !     hsu * rcp * dT/dt = Fsr + Fnsr(T) + Fcs(T),
+      !     where - Fsr is the net absorbed solar radiation, 
+      !           - Fnsr is the total non solar radiation (incoming and outgoing long-wave,
+      !             sensible and latent heat fluxes)
+      !           - Fcs the conductive heat flux at the top of surface
+      !------------------------------------------------------------------------------
+
+      !     4.1. Computation of intermediate values
+      !---------------------------------------------
+      DO ji = kideb, kiut
+         zrcpdt(ji) = ( rcpsn * MIN( h_snow_1d(ji) , zhsu )    &
+            &       + rcpic * MAX( zhsu - h_snow_1d(ji) , zzero ) ) / rdt_ice
+         zts_old(ji) =  sist_1d(ji)
+      END DO
+
+      !     4.2. Computation of surface temperature by expanding the eq. of energy balance
+      !          with Ts = Tp + DT. One obtain , F(Tp) + DT * DF(Tp) = 0
+      !          where  - F(Tp) = Fsr + Fnsr(Tp) + Fcs(Tp) 
+      !                 - DF(Tp)= (dFnsr(Tp)/dT) + (dFcs(Tp)/dT) - hsu*rcp/dt
+      !---------------------------------------------------------------------------------
+
+      DO ji = kideb, kiut
+         !---computation of the derivative of energy balance function 
+         zdfts    =  zksndh(ji)   & ! contribution of the conductive heat flux
+            &      + zrcpdt(ji)   & ! contribution of hsu * rcp / dt
+            &      - dqns_ice_1d (ji)     ! contribution of the total non solar radiation 
+         !---computation of the energy balance function 
+         zfts    = - z1mi0 (ji) * qsr_ice_1d(ji)   & ! net absorbed solar radiation
+            &      - qns_ice_1d(ji)                & ! total non solar radiation
+            &      - zfcsu (ji)                      ! conductive heat flux from the surface
+         !---computation of surface temperature increment  
+         zdts    = -zfts / zdfts
+         !---computation of the new surface temperature 
+         sist_1d(ji) = sist_1d(ji) + zdts
+      END DO
+
+      !----------------------------------------------------------------------------
+      !  5. Boundary condition at the top surface
+      !--    IF Tsb < Tmelt, Fnet = Fcs (the net heat flux equal the conductive heat flux)
+      !      Otherwise Tsb = Tmelt and Qnet(Tmelt) > 0 
+      !      Fnet(Tmelt) is therefore the net surface flux needed for melting
+      !----------------------------------------------------------------------------
        
        
-       !     5.1.  Limitation of surface temperature and update total non solar fluxes,
-       !          latent heat flux and conductive flux at the top surface 
-       !----------------------------------------------------------------------  
+      !     5.1.  Limitation of surface temperature and update total non solar fluxes,
+      !          latent heat flux and conductive flux at the top surface 
+      !----------------------------------------------------------------------  
                      
-       IF ( .NOT. lk_cpl ) THEN   ! duplicate the loop for performances issues
-          DO ji = kideb, kiut
-             sist_1d(ji) = MIN( ztsmlt(ji) , sist_1d(ji) )
-             qns_ice_1d(ji) = qns_ice_1d(ji) + dqns_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
-             qla_ice_1d(ji) = qla_ice_1d(ji) + dqla_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
-             zfcsu(ji)  = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
-          END DO
-       ELSE
-          DO ji = kideb, kiut
-             sist_1d(ji) = MIN( ztsmlt(ji) , sist_1d(ji) )
-             zfcsu(ji)  = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
-          END DO
-       ENDIF
-
-       !     5.2. Calculate available heat for surface ablation. 
-       !---------------------------------------------------------------------
-
-       DO ji = kideb, kiut
-          zfnet(ji) = qns_ice_1d(ji) + z1mi0(ji) * qsr_ice_1d(ji) + zfcsu(ji)          
-          zfnet(ji) = MAX( zzero , zfnet(ji) )
-          zfnet(ji) = zfnet(ji) * MAX( zzero , SIGN( zone , sist_1d(ji) - ztsmlt(ji) ) )
-       END DO
-
-       !-------------------------------------------------------------------------
-       !  6. Calculate changes in internal temperature due to vertical diffusion   
-       !     processes. The evolution of this temperature is governed by the one-
-       !     dimensionnal heat-diffusion equation. 
-       !     Given the temperature tbif(1/2/3), at time m we solve a set
-       !     of finite difference equations to obtain new tempe. Each tempe is coupled
-       !     to the temp. immediatly above and below by heat conduction terms. Thus 
-       !     we have a set of equations of the form A * T = B, where A is a tridiagonal
-       !     matrix, T a vector whose components are the unknown new temp.
-       !-------------------------------------------------------------------------
+      IF ( .NOT. lk_cpl ) THEN   ! duplicate the loop for performances issues
+         DO ji = kideb, kiut
+            sist_1d(ji) = MIN( ztsmlt(ji) , sist_1d(ji) )
+            qns_ice_1d(ji) = qns_ice_1d(ji) + dqns_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
+            qla_ice_1d(ji) = qla_ice_1d(ji) + dqla_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
+            zfcsu(ji)  = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
+         END DO
+      ELSE
+         DO ji = kideb, kiut
+            sist_1d(ji) = MIN( ztsmlt(ji) , sist_1d(ji) )
+            zfcsu(ji)  = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
+         END DO
+      ENDIF
+
+      !     5.2. Calculate available heat for surface ablation. 
+      !---------------------------------------------------------------------
+
+      DO ji = kideb, kiut
+         zfnet(ji) = qns_ice_1d(ji) + z1mi0(ji) * qsr_ice_1d(ji) + zfcsu(ji)          
+         zfnet(ji) = MAX( zzero , zfnet(ji) )
+         zfnet(ji) = zfnet(ji) * MAX( zzero , SIGN( zone , sist_1d(ji) - ztsmlt(ji) ) )
+      END DO
+
+      !-------------------------------------------------------------------------
+      !  6. Calculate changes in internal temperature due to vertical diffusion   
+      !     processes. The evolution of this temperature is governed by the one-
+      !     dimensionnal heat-diffusion equation. 
+      !     Given the temperature tbif(1/2/3), at time m we solve a set
+      !     of finite difference equations to obtain new tempe. Each tempe is coupled
+      !     to the temp. immediatly above and below by heat conduction terms. Thus 
+      !     we have a set of equations of the form A * T = B, where A is a tridiagonal
+      !     matrix, T a vector whose components are the unknown new temp.
+      !-------------------------------------------------------------------------
        
-       !--parameter for the numerical methode use to solve the heat-diffusion equation
-       !- implicit, explicit or Crank-Nicholson
-       zumsb = 1.0 - sbeta  
-       DO ji = kideb, kiut
-          zidsn(ji)   = MAX ( zzero, SIGN( zone, hsndif - h_snow_1d(ji) ) ) 
-          z1midsn(ji) = 1.0 - zidsn(ji)
-          zihic       = MAX ( zzero, SIGN( zone, hicdif - h_ice_1d(ji) ) ) 
-          zidsnic(ji) = zidsn(ji) *  zihic 
-          zfcsudt(ji) = zfcsu(ji) * rdt_ice 
-       END DO 
+      !--parameter for the numerical methode use to solve the heat-diffusion equation
+      !- implicit, explicit or Crank-Nicholson
+      zumsb = 1.0 - sbeta  
+      DO ji = kideb, kiut
+         zidsn(ji)   = MAX ( zzero, SIGN( zone, hsndif - h_snow_1d(ji) ) ) 
+         z1midsn(ji) = 1.0 - zidsn(ji)
+         zihic       = MAX ( zzero, SIGN( zone, hicdif - h_ice_1d(ji) ) ) 
+         zidsnic(ji) = zidsn(ji) *  zihic 
+         zfcsudt(ji) = zfcsu(ji) * rdt_ice 
+      END DO 
    
-       DO ji = kideb, kiut
-
-          !     6.1 Calculate intermediate variables.
-          !----------------------------------------
-
-          !--conductivity at the snow surface
-          zkhsn = 2.0 * zksn(ji) * rdt_ice / rcpsn
-          !--conductivity at the ice surface
-          zkhic = 4.0 * zkic(ji) * rdt_ice / MAX( h_ice_1d(ji) * h_ice_1d(ji) * rcpic , epsi20 )
-          !--conductivity at the snow/ice interface 
-          zkint = 4.0 * zksn(ji) * zkic(ji)  &
-             &        / ( zksn(ji) * h_ice_1d(ji) + 2.0 * zkic(ji) * h_snow_1d(ji) * z1midsn(ji)) 
-          zkhsnint = zkint * rdt_ice / rcpsn
-          zkhicint = zkint * 2.0 * rdt_ice / MAX( h_ice_1d(ji) * rcpic , epsi20 )
-          
-          !     6.2. Fulfill the linear system matrix.
-          !-----------------------------------------
+      DO ji = kideb, kiut
+
+         !     6.1 Calculate intermediate variables.
+         !----------------------------------------
+
+         !--conductivity at the snow surface
+         zkhsn = 2.0 * zksn(ji) * rdt_ice / rcpsn
+         !--conductivity at the ice surface
+         zkhic = 4.0 * zkic(ji) * rdt_ice / MAX( h_ice_1d(ji) * h_ice_1d(ji) * rcpic , epsi20 )
+         !--conductivity at the snow/ice interface 
+         zkint = 4.0 * zksn(ji) * zkic(ji)  &
+            &        / ( zksn(ji) * h_ice_1d(ji) + 2.0 * zkic(ji) * h_snow_1d(ji) * z1midsn(ji)) 
+         zkhsnint = zkint * rdt_ice / rcpsn
+         zkhicint = zkint * 2.0 * rdt_ice / MAX( h_ice_1d(ji) * rcpic , epsi20 )
+          
+         !     6.2. Fulfill the linear system matrix.
+         !-----------------------------------------
 !$$$          zplediag(1) = 1 + sbeta * z1midsn(ji) * ( zkhsn + zkhsnint )       
-          zplediag(1) =   zidsn(ji) + z1midsn(ji) * h_snow_1d(ji)   &
-             &          + sbeta * z1midsn(ji) * zkhsnint 
-          zplediag(2) = 1 + sbeta * ( z1midsn(ji) * zkhicint + zkhic ) 
-          zplediag(3) = 1 + 3.0 * sbeta * zkhic   
-
-          zsubdiag(1) =  0.e0              
-          zsubdiag(2) = -1.e0 * z1midsn(ji) * sbeta * zkhicint
-          zsubdiag(3) = -1.e0 * sbeta * zkhic 
-
-          zsupdiag(1) = -1.e0 * z1midsn(ji) * sbeta * zkhsnint 
-          zsupdiag(2) = zsubdiag(3)
-          zsupdiag(3) =  0.e0
-          
-          !     6.3. Fulfill the idependent term vector.
-          !-------------------------------------------
+         zplediag(1) =   zidsn(ji) + z1midsn(ji) * h_snow_1d(ji)   &
+            &          + sbeta * z1midsn(ji) * zkhsnint 
+         zplediag(2) = 1 + sbeta * ( z1midsn(ji) * zkhicint + zkhic ) 
+         zplediag(3) = 1 + 3.0 * sbeta * zkhic   
+
+         zsubdiag(1) =  0.e0              
+         zsubdiag(2) = -1.e0 * z1midsn(ji) * sbeta * zkhicint
+         zsubdiag(3) = -1.e0 * sbeta * zkhic 
+
+         zsupdiag(1) = -1.e0 * z1midsn(ji) * sbeta * zkhsnint 
+         zsupdiag(2) = zsubdiag(3)
+         zsupdiag(3) =  0.e0
+          
+         !     6.3. Fulfill the idependent term vector.
+         !-------------------------------------------
           
 !$$$          zsmbr(1) = zidsn(ji) * sist_1d(ji) + z1midsn(ji) *   &
